# simulation for (1)
library(pscl)
library(mclust)
library(tmvtnorm)
library(DPpackage)
load("adjacency.bin")
aa<-matrix

## fix beta=1 pi0=0.8
 set.seed(1111)
generate=function(n,bb0,bb1,pi0){
z<-c(rep(c(1,0,0),100),rep(0,700))
names(z)<-paste("x",1:1000,sep="")

for(i in 1: n){

pro1<-0
pro0<-0
for(num1 in 1:1000){
idx = which(aa[num1,]==1)

pro0=sum(z[idx]==0)
pro1=sum(z[idx]==1)

#for(j in 1:1000){
#if(matrix[num1,j]==1){
#if(z[j]==1){
#pro1<-pro1+1}else{
#pro0<-pro0+1}
#}



#g12<-sum((exp(-(traincov[num1]- a[id])^2/(2*b[id]))/sqrt(2*pi*b[id])))/length(a[id])
#g11<-exp(2*pro1)
#log12<-log(g12)
#log11<-log(g11)
#log1<-log12+log11



log0<-log(pi0)+(2*bb0*pro0)

log1<-log(1-pi0)+(2*bb1*pro1)



p0<-1/(1+exp(log1-log0))
p1<-1-p0

z[num1]<-sample(c(0,1),1,prob=c(p0,p1))
}
}
return(z)
}
newz<-generate(10000,0.5,1,0.8)

##generate train dataset and test dataset
## do the cross validition first in order to select the proper beta

set.seed(1111)
testcov<-0
for(i in 1:1000){
if(newz[i]==0){
testcov[i]<-rnorm(1,mean=0,sd=0.2)

}else{
testcov[i]<-rnorm(1,mean=0.5,sd=0.2)

}
}



##get initals  all by mclust
##get the clusters each nodes belongs to

clust<-Mclust(testcov)
clust$parameters

mu0<--0.008535099
mu1<-0.485399726
var0=var1=0.03984323
### after use 5 10 0.8

mu0<--0.003581923
mu1<-0.527062225
var0=var1=0.03769248

## get the likelihood to select parameters


set.seed(1111)
z<-results
mylog<-0
for(num1 in 1:1000){

if(z[num1]==0){
mylog[num1]<--(testcov[num1]-mu0)^2/(2*var0)-log(sqrt(var0))
}else{
mylog[num1]<--(testcov[num1]-mu1)^2/(2*var1)-log(sqrt(var1))
}

}
sum(mylog)


result<-results[2000:200,]
like<-apply(result,2,mean)
sum(like)

## our method


set.seed(1111)
method<-function(n,bb0,pi0){
z<-c(rep(c(1,0,0),100),rep(0,700))

total<-matrix(rep(0,1000*n),ncol=1000,nrow=n)

for(jj in 1: n){
for(num1 in 1:1000){

pro1<-0
pro0<-0
idx = which(aa[num1,]==1)

pro0=sum((z[idx]==0))
pro1=sum((z[idx]==1))



log0<-log(pi0)+(2*bb0*pro0-(testcov[num1]-mu0)^2*12.85161)+0.7043695

log1<-log(1-pi0)+(2*bb1*pro1-(testcov[num1]-mu1)^2*12.85161)+0.7043695



p0<-1/(1+exp(log1-log0))
p1<-1-p0

z[num1]<-sample(c(0,1),1,prob=c(p0,p1))

if(jj==1){total[jj,num1]<-z[num1]}else{
total[jj,num1]<-total[jj-1,num1]+z[num1]
}
#ratio[jj,num1]<-total[jj,num1]/jj

}
}

return(total)
}


## Dpdensity is used to compare
nburn <-2000
nsave <-10000
nskip <-0
ndisplay <-0
mcmc <- list(nburn=nburn,nsave=nsave,nskip=nskip,ndisplay=ndisplay)
#prior1 <- list(alpha=0.5,m1=0.2,nu1=100,psiinv1=0.1,k0=100)
prior2 <- list(a0=2,b0=1,m2=rep(0,1),s2=diag(100000,1),
                   psiinv2=solve(diag(0.5,1)),
                   nu1=4,nu2=4,tau1=1,tau2=100)
fit<-DPdensity(testcov,prior=prior2,mcmc=mcmc,status=TRUE)

##cluster

hh1<-1/2/sqrt(pi*sigmaclus[1])+1/2/sqrt(pi*sigmaclus[3])-2*dnorm(muclus[1],muclus[3],sd=sqrt(sigmaclus[3]+sigmaclus[1]))

hh2<-1/2/sqrt(pi*sigmaclus[2])+1/2/sqrt(pi*sigmaclus[3])-2*dnorm(muclus[2],muclus[3],sd=sqrt(sigmaclus[2]+sigmaclus[1]))


# hh1<-5.551893  hh2<-5.551893

#####clustering function







mycluster<-function(n){
results<-list()
for(oo in 1:n){

nburn <-2000
nsave <-5000
nskip <-0
ndisplay <-0
mcmc <- list(nburn=nburn,nsave=nsave,nskip=nskip,ndisplay=ndisplay)
#prior1 <- list(alpha=0.5,m1=0.2,nu1=100,psiinv1=0.1,k0=100)
prior2 <- list(a0=2,b0=1,m2=rep(0,1),s2=diag(100000,1),
                   psiinv2=solve(diag(0.5,1)),
                   nu1=4,nu2=4,tau1=1,tau2=100)
fit<-DPdensity(testcov,prior=prior2,mcmc=mcmc,status=TRUE)

##calculate cluster
ss<-fit$state$ss
num<-fit$state$ncluster
prop<-table(fit$state$ss)/num
mu<-fit$state$muclus[1:num]
sigma<-fit$state$sigmaclus[1:num]
index<-order(mu,decreasing=T)
newm<-mu[index]
news<-sigma[index] 
newp<-prop[index]


if(num==2 | num==1){results[[oo]]<-ss-1}else{
#hh1<-1/2/sqrt(pi*news[1])+1/2/sqrt(pi*news[2])-2*dnorm(newm[1],newm[2],sd=sqrt(news[1]+news[2]))

#hh2<-1/2/sqrt(pi*news[2])+1/2/sqrt(pi*news[3])-2*dnorm(newm[2],newm[3],sd=sqrt(news[2]+news[3]))

clmatrix<-matrix(rep(0,num*num),ncol=num,nrow=num)
for(i in 1:num){
for(j in 1:num){
clmatrix[i,j]<-dnorm(newm[i],newm[j],sd=sqrt(news[i]+news[j]))

}
}


temp1<-0
temp2<-0
com1<-0
com2<-0
res1<-0
res2<-0
final1<-0
final2<-0
latent<-0
latent[1]<-0
final1<-c(1,-1,rep(0,num-2))
final2<-c(0,-1,1,rep(0,num-3))

for(iii in 1:(num-2)){
dec1<-t(final1)%*%clmatrix%*%final1
dec2<-t(final2)%*%clmatrix%*%final2

if(dec1>dec2){latent[iii+1]<-1
}else{
latent[iii+1]<-0
}
if(latent[iii+1]==1){
ddd<-max(which(latent==0))
temp1<-rep(0,num)
temp1[1:ddd]<-1
com1<-temp1*newp
com1<-scale(com1,center=F,scale=sum(com1))
temp1<-rep(0,num)
temp1[(ddd+1):(iii+1)]<--1
res1<-temp1*newp
res1<-scale(res1,center=F,scale=sum(abs(res1)))
final1<-com1+res1
temp2<-rep(0,num)
temp2[(ddd+1):(iii+1)]<--1
res2<-temp2*newp
res2<-scale(res2,center=F,scale=sum(abs(res2)))
com2<-rep(0,num)
com2[iii+2]<-1
final2<-com2+res2
}else{
temp1<-rep(0,num)
temp1[1:iii]<-1
com1<-temp1*newp
com1<-scale(com1,center=F,scale=sum(com1))
res1<-rep(0,num)
res1[iii+1]<--1
final1<-com1+res1
final2<-rep(0,num)
final2[iii+1]<--1
final2[iii+2]<-1
}


}
latent[num]<-1

uuu<-max(which(latent==0))
ss[ss %in% index[(uuu+1):num]]<-0
ss[ss %in% index[1:uuu]]<-1
results[[oo]]<-ss
}
}
return(results)
}
results<-mycluster(100)

mycluster<-do.call(rbind,results)






sss=matrix(rep(NA,2031*5000),ncol=2031)
for(ii in 5001:10000){
index=sort(unique(fit$save.state$randsave[ii,0:2030*2+1]))
myss=as.matrix(fit$save.state$randsave[ii,0:2030*2+1])

sss[ii-5000,]=apply(myss,1,function(cc) which(index==cc))

}
